--Klein, xtimes function (8 bits)

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY klein_xtimes IS
  PORT (
    x_in  : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    x_out : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
    );
END klein_xtimes;


ARCHITECTURE rtl OF klein_xtimes IS

  SIGNAL le : STD_LOGIC_VECTOR(7 DOWNTO 0);
  SIGNAL ri : STD_LOGIC_VECTOR(7 DOWNTO 0);

BEGIN

  x_out(0) <= x_in(7);
  x_out(1) <= x_in(7) XOR x_in(0);
  x_out(2) <= x_in(1);
  x_out(3) <= x_in(7) XOR x_in(2);
  x_out(4) <= x_in(7) XOR x_in(3);
  x_out(5) <= x_in(4);
  x_out(6) <= x_in(5);
  x_out(7) <= x_in(6);


END rtl;

